"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var ui_model_1 = require('ui-model');
var RADIO_GROUP_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return RadioGroupComponent; }),
    multi: true,
};
var RadioGroupComponent = (function () {
    function RadioGroupComponent() {
        this.select = new ui_model_1.Select();
    }
    RadioGroupComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.sub = this.select.changes.subscribe(function (selection) {
            if (_this.onChange) {
                _this.onChange(selection);
            }
            if (_this.onTouched) {
                _this.onTouched();
            }
        });
    };
    RadioGroupComponent.prototype.ngOnDestroy = function () {
        this.sub.unsubscribe();
    };
    RadioGroupComponent.prototype.writeValue = function (value) {
        this.select.select(value);
    };
    RadioGroupComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    RadioGroupComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], RadioGroupComponent.prototype, "options", void 0);
    RadioGroupComponent = __decorate([
        core_1.Component({
            selector: 'ui-radio-group',
            templateUrl: 'radio-group.component.html',
            styleUrls: ['radio-group.component.scss'],
            providers: [RADIO_GROUP_VALUE_ACCESSOR]
        }), 
        __metadata('design:paramtypes', [])
    ], RadioGroupComponent);
    return RadioGroupComponent;
}());
exports.RadioGroupComponent = RadioGroupComponent;

//# sourceMappingURL=radio-group.component.js.map
